//-----------------------------------------------------------------------------
// EDIT AT YOUR OWN RISK!
//
// Automatically generated by porky (http://...)
// from the specification:
/*
${pythonrepr}
 */
//-----------------------------------------------------------------------------

#include <cstring>
#include <iostream>
#include <sstream>
#include <map>

#include <stdint.h>

#include "piglet.h"

#include "expr_visitor.h"
#include "patcher.h"

using namespace std;

#define ALEN(arr)    (sizeof(arr) / sizeof(arr[0]))
#define NYI(what)                               \
    do {                                        \
        cerr <<"NYI: "<< what <<endl;           \
        abort();                                \
    } while (0)
#define UNREACHED(what)                                         \
    do {                                                        \
        cerr <<"shouldn't have reached: "<< what <<endl;        \
        abort();                                                \
    } while (0)

//-----------------------------------------------------------------------------

#define declarator_foreach_ideclarator(d, id)           \
    for (const IDeclarator* id = (d)->decl; id; id = (id)->getBaseC())

//-----------------------------------------------------------------------------
// XXX this section needs to be kept in sync with the code that porky.py
// generates.
//
struct TypeRule {
    const char* const base_name;
    const char* const qualifiers;
    const char* const to_base_name;
    const char* const to_qualifiers;
    
    bool match(const sm::string& type_name, const Declarator* decl,
               const D_name** outVarName, const IDeclarator**outFirstQual) {
        const D_name* varName = 0;
        const IDeclarator* firstQual = 0;

        const char* qp = qualifiers;
        declarator_foreach_ideclarator(decl, idecl) {
            if (!firstQual)
                firstQual = idecl;

            if (!*qp 
                && IDeclarator::D_NAME == idecl->kind()
                && type_name == base_name) {
                varName = (const D_name*) idecl;
                goto out;
            } else if (!*qp || IDeclarator::D_NAME == idecl->kind()) {
                goto out;
            }
            
            switch (*qp) {
            case '*':
                if (IDeclarator::D_POINTER != idecl->kind())
                    goto out;
                break;
            case '&':
                if (IDeclarator::D_REFERENCE != idecl->kind())
                    goto out;
                break;
            case '[':
                if (IDeclarator::D_ARRAY!= idecl->kind())
                    goto out;
                break;

            default:
                UNREACHED(idecl->kindName());
            }
            ++qp;

            firstQual = idecl;
        }
out:
        if (outVarName && varName) {
            *outVarName = varName;
            if (outFirstQual)
                *outFirstQual = firstQual;
        }
        return varName;
    }

    string makeNewDeclarator(const char* varName) {
        string s = to_qualifiers;
        // STYLE CUSTOMIZATION: is it "Foo* f" or "Foo *f"?
        return s +" "+ varName;
    }
};
ostream& operator<<(ostream& os, const TypeRule& rule) {
    return os <<"<TypeRule match="
              << rule.base_name << rule.qualifiers 
              << " changeto="
              << rule.to_base_name << rule.to_qualifiers
              << ">";
}
ostream& operator<<(ostream& os, const TypeRule* rule) {
    return os << *rule;
}

#define foreach_type_rule(r)                                    \
    for (TypeRule* r = &_type_rules[0]; (r)->base_name; ++r)

${type_rule_decls}

//-----------------------------------------------------------------------------
// XXX this section needs to be kept in sync with the code that porky.py
// generates.
//

/** After we've matched a function, each write_instr tells us how to emit
 * part of the rewritten function.  An instruction is one of 
 *   |  EMIT_STRING  (const char *)|: emit a literal string
 *   |EMIT_CAPT_ARG  (uint)|: emit a captured argument
 *   |         HALT  (xxx)|: done emitting stuff
 * |WriteInstr|'s store a single intptr_t argument, which is interpreted
 * according to the instruction type.
 */
struct WriteInstr {
    enum { EMIT_STRING, EMIT_CAPT_ARG, HALT } op;
    uintptr_t opnd;

    /** Execute the operation on |out|.  Return true if done. */
    bool exec(ostream& out, const vector<string>& args) const {
        const char* str = 0;

        switch(op) {
        case HALT: return false;
        case EMIT_STRING:
            str = (const char*) opnd;
            xassert(str);
            out << str;
            return true;
        case EMIT_CAPT_ARG:
            xassert(opnd < args.size());
            out << args[opnd];
            return true;
        default:                // not reached
            xassert(0);
            return false;
        }
    }
};

struct CallRule {
    const char* callable;
    int nargs;                  // -1 means any number of args
    const WriteInstr* wprog;
    
    bool match(const string& fname, const vector<string>& captArgs) {

        cout <<"fname: "<< fname 
             <<", captArgs: "<< captArgs.size()
             <<", callable: "<< callable
             <<endl;


        if (fname != callable) {
            cout << "  Reject: "
                 <<"'"<<fname<<"' != '"<<callable<<"'"
                 <<endl;
            return false;
        }

        if (0 <= nargs && ((int) captArgs.size()) != nargs) {
            cout << "  Reject: "
                 <<"'"<< captArgs.size()<<"' != '"<<nargs<<"'"<<
                endl;
            return false;
        }
        return true;
    }

    string makeNewFuncall(const vector<string>& captArgs) {
        ostringstream out;
        while (wprog->exec(out, captArgs))  ++wprog;
        return out.str();
    }
};
ostream& operator<<(ostream& os, const CallRule& rule) {
    return os <<"<CallRule callable="<< rule.callable <<" ...>";
}
ostream& operator<<(ostream& os, const CallRule* rule) {
    return os << *rule;
}

#define foreach_call_rule(r)                                    \
    for (CallRule* r = &_call_rules[0]; (r)->callable; ++r)

const char dot[] = ".";
const char arrow[] = "->";
const char lparen[] = "(";
const char comma[] = ", ";
const char rparen[] = ")";

#if 1
${call_rule_decls}
#endif

#if 0
const char _call_rule_0_callable[] = "foo";
const char _call_rule_0_prog_str0[] = "barbar";
WriteInstr _call_rule_0_prog[] = {
    { WriteInstr::EMIT_STRING,   (uintptr_t) _call_rule_0_prog_str0 },
    { WriteInstr::EMIT_STRING,   (uintptr_t) lparen },
    { WriteInstr::EMIT_CAPT_ARG, (uintptr_t) 1 },
    { WriteInstr::EMIT_STRING,   (uintptr_t) comma },
    { WriteInstr::EMIT_CAPT_ARG, (uintptr_t) 0 },
    { WriteInstr::EMIT_STRING,   (uintptr_t) rparen },
    { WriteInstr::HALT, (uintptr_t) 0 },
};

CallRule _call_rules[] = {
    { _call_rule_0_callable, 2, _call_rule_0_prog },
    { 0, 0, 0 }
};
#endif

//-----------------------------------------------------------------------------

class ${renamer} : public ExpressionVisitor {
protected:
    void 
    renameAt(CPPSourceLoc csl, string const &renameTo, int offset) 
    {
    }

public:
    ${renamer}(Patcher& patcher)
        : patcher(patcher) {
    }

    virtual bool
    visitDeclaration(Declaration* d) 
    {
        DeclFlags flags = d->dflags;

        // don't (/shouldn't/) care about builtins
        if (DF_BUILTIN & flags)
            return false;

        const char* newTypeSpec = 0;
        TypeSpecifier *t = d->spec;
        sm::string type_name;

        // locate the "name" of this type specifier, e.g. "FooClass"
        switch (t->kind()) {
        case TypeSpecifier::TS_NAME:
            type_name = ((TS_name*) t)->name->toString();
            break;
        case TypeSpecifier::TS_CLASSSPEC:
            type_name = ((TS_classSpec*) t)->name->toString();
            break;
        case TypeSpecifier::TS_SIMPLE:
            type_name = simpleTypeName(((TS_simple*) t)->id);
            break;

        default:
// TODO
//        case TS_ELABORATED:  // struct/enum/... [name]
//        case TS_ENUMSPEC:    // enum { [elts] }
            NYI(t->kindName());
        }

        FakeList<Declarator>* decls = d->decllist;
        FAKELIST_FOREACH(Declarator, decls, decl) {
            foreach_type_rule(rule) {
                const D_name* var;
                const IDeclarator* firstQual;
                if (rule->match(type_name, decl, &var, &firstQual)) {
                    // this may be set multiple times for declarators in 
                    // this declaration, but since they all share the same
                    // TypeSpecifier, rule->to_base_name must always be the
                    // the same
                    newTypeSpec = rule->to_base_name;

                    sm::string varName = var->name->toString();
                    string newDecl = rule->makeNewDeclarator(varName.c_str());

                    UnboxedLoc startloc;
                    const char *filename = startloc.set(firstQual->loc);

                    UnboxedLoc endloc;
                    endloc.set(var->name->loc);
                    endloc.col += varName.length();

                    patcher.printPatch (
                        newDecl, UnboxedPairLoc(filename, startloc, endloc));
                    goto next_declarator;
                }
            }
next_declarator:
            continue;
        }

        if (newTypeSpec) {
            UnboxedLoc startloc;
            const char *filename = startloc.set(t->loc);
            UnboxedLoc endloc;
            endloc.set(t->loc);
            endloc.col += type_name.length();

            patcher.printPatch(newTypeSpec, 
                               UnboxedPairLoc(filename, startloc, endloc));
        }

        return !newTypeSpec;
    }

    virtual bool
    visitE_funCall(E_funCall* fc)
    {
        string fname;
        int nargs = 0;
        vector<string> captArgs;

        if (fc->func->ifE_variable()) {
            fname = fc->func->asE_variable()->name->toString().c_str();
        } 
        // TODO oy vey iz mir.  I would expect a lowering pass to remove
        // method call crap and convert to something like 
        // Base::foo(this, ...), but elsa doesn't do this.  
        // so here we hack in the fully-qualified function name and
        // |this| argument, if they exist.
        // TODO doesn't consider inheritance
        else if (fc->func->ifE_fieldAcc()) {
            E_fieldAcc* efa = fc->func->asE_fieldAcc();
            BaseType* type = (BaseType*) efa->obj->getType();

            while (1) {
                if (type->isPointerType())
                    type = type->asPointerType()->atType;
                else if (type->isReferenceType())
                    type = type->asReferenceType()->atType;
                else
                    break;
            }

            fname = type->toCString().c_str();
            fname += "::";
            fname += efa->fieldName->toString().c_str();

            captArgs.push_back(patcher.getRange(
                                   PairLoc(efa->obj->loc, efa->obj->endloc)));
            nargs = 1;
        } else {
            // warning("don't understand ...");
            return true;
        }

        FAKELIST_FOREACH(ArgExpression, fc->args, arg) {
            captArgs.push_back(
                patcher.getRange(
                    PairLoc(arg->expr->loc, arg->expr->endloc)));
            ++nargs;
        }

        foreach_call_rule(c) {
            if (c->match(fname, captArgs)) {
                patcher.printPatch(
                    c->makeNewFuncall(captArgs),
                    // special case when we want to replace a function's
                    // name only, i.e., we don't care what the args are
                    (0 <= fc->args) ?
                        PairLoc(fc->loc, fc->endloc)
                      : PairLoc(fc->func->loc, fc->func->endloc));
                return false;
            }
        }

        return true;
    }

private:
    Patcher patcher;
};

//-----------------------------------------------------------------------------

int
main(int argc, char **argv)
{
    xassert(argc > 1);

    PigletParser parser;
    Patcher p;
    ${renamer} visitor(p);

    for (int i = 1; i < argc; ++i) {
        TranslationUnit *unit = parser.getASTNoExc(argv[i]);
        unit->traverse(visitor);
    }
    return 0;
}
